local L = LibStub("AceLocale-3.0"):GetLocale("Deadpool", true)

function encodeAndSendDeadpoolSessionInfo(aData, aSender, aMessageTime)
	if aData then
		aData["DeadpoolSessionId"] = DeadpoolGlobal_SessionId
		--Deadpool:Print(time().." - Preparing message.")
		local s = Deadpool:Serialize(aData)
		--Deadpool:Print(time().." - Message OK.")
		if aSender and aMessageTime then
			Deadpool:SendCommMessage(DeadpoolGlobal_CommPrefix, "Data#"..aMessageTime.."#"..s, "WHISPER", aSender)
			--Deadpool:Print(time().." - Message envoye.")
			--Deadpool:Print("Sent data to "..aSender..".")
		else
			Deadpool:SendCommMessage(DeadpoolGlobal_CommPrefix, "Data#"..tostring(Deadpool_getTimeUTCinMS()).."#"..s, "RAID")
			--Deadpool:Print("Sent data to raid.")
		end
	end
end

function encodeAndSendSimpleDeadpoolData(aData)
	local t = aData
	local s = Deadpool:Serialize(t)
	Deadpool:SendCommMessage(DeadpoolGlobal_CommPrefix, "SimpleData#"..tostring(Deadpool_getTimeUTCinMS()).."#"..s, "RAID")
end

function Deadpool:ReceiveDataFrame_OnEvent(prefix, message, distribution, sender)
	if prefix == DeadpoolGlobal_CommPrefix then
		--Deadpool:Print(time().." - Received message from "..sender..".")
		local messageType, messageTime, messageMessage, messageParam = strsplit("#", message, 4)
		if not Deadpool_isPlayerCharacter(sender) then
			if messageType == "Data" or messageType == "SimpleData" then
				local success, o = self:Deserialize(messageMessage)
				if success == false then
					Deadpool:Print(time().." - Received corrupted data from "..sender..".")
				else
					if DeadpoolReceivedData
						and DeadpoolReceivedData["CallTime"]
							and DeadpoolReceivedData["CallTime"] == messageTime then
						-- do nothing
						--Deadpool:Print(time().." - Received already processed "..messageType.." from "..sender..".")
					else
						--Deadpool:Print(time().." - Received "..messageType.." from "..sender..".")
						if not DeadpoolReceivedData then
							DeadpoolReceivedData = {}
						end
						DeadpoolReceivedData[DeadpoolGlobal_SessionId] = o
						DeadpoolReceivedData["CallTime"] = messageTime
						DeadpoolReceivedData["Sender"] = sender
						if o and o["DeadpoolSessionId"] then
							DeadpoolReceivedData["DeadpoolSessionId"] = o["DeadpoolSessionId"]
						end
						loadReceivedDeadpoolData(messageType)
					end
				end
			elseif messageType == "Call" then
				encodeAndSendDeadpoolSessionInfo(DeadpoolData[DeadpoolGlobal_SessionId], sender, messageTime)
			end
		end
		if messageType == "VersionCall" then
			sendDeadpoolVersion(sender)
		end
		if messageType == "Version" then
			Deadpool:Print(sender..L["SPACE_BEFORE_DOT"]..": "..messageMessage)
		end
	end
end

function Deadpool:CallForDeadpoolData(event)
	--Deadpool:Print(time().." - Calling data!")
	if event and event == "GROUP_JOINED" then
		tellTutorialText("DEADPOOLTUTO_TUTO6")
		playerJoinsDeadpoolSession("DeadpoolSession_"..Deadpool_playerCharacter(), true)
	end
	SendAddonMessage(DeadpoolGlobal_CommPrefix, "Call#"..tostring(Deadpool_getTimeUTCinMS()), "RAID")
end

function checkDeadpoolVersion()
	SendAddonMessage(DeadpoolGlobal_CommPrefix, "VersionCall#"..tostring(Deadpool_getTimeUTCinMS()), "RAID")
end

function sendDeadpoolVersion(aSender)
	SendAddonMessage(DeadpoolGlobal_CommPrefix, "Version#"..tostring(Deadpool_getTimeUTCinMS()).."#"..GetAddOnMetadata("Deadpool", "Version"), "WHISPER", aSender)
end
